var ResourceLists = {};

ResourceLists.AutoInit = () => {
  for (let propertyName in ResourceLists) {
    let property = ResourceLists[propertyName];
    // Call autoInit of all properties that are subclasses of `ResourceLists.ResourceList`.
    // This does not include `ResourceLists.ResourceList` itself.
    if (property.prototype instanceof ResourceLists.ResourceList) {
      // Check if the static `htmlClass` property is defined.
      if (property.htmlClass === undefined) {return;}
      // Gather all HTML elements that have the `this.htmlClass` class
      // and do not have the `no-autoinit` class.
      let listElements = document.querySelectorAll(`.${property.htmlClass}:not(.no-autoinit)`);
      // Create an instance of this class for each display element.
      for (let listElement of listElements) {new property(listElement);}
    }
  }
};
